/*
 * $Id: nemesis-ospf.c,v 1.3 2000/01/16 10:31:55 obecian Exp $
 *
 * THE NEMESIS PROJECT (c) obecian 1999
 *
 * ospf.c (OSPF Packet Injector)
 *
 */

#include "nemesis-ospf.h"

int
main(int argc, char **argv)
{
	int             m;
	int             opt;
	char           *file = NULL;
	char            buff[512];
	FILE           *pay = NULL;
	extern char    *optarg;
	extern int      opterr;
	extern char	   *nemesis_version;

	int             bindata = 0;

	got_link = 0;
	got_options = 0;
	got_payload = 0;

	if (argc < 2)
		usage(argv[0]);

	if (geteuid() != 0) {
		printf("user '%s' does not have an euid of 0\n", getlogin());
		exit(1);
	}
	defaults();

	opterr = 0;
	while ((opt = getopt(argc, argv, "S:D:r:s:d:F:H:M:L:R:A:f:g:G:N:n:i:l:o:O:P:m:x:B:y:k:I:T:t:z:u:p:bv")) != EOF) {
		switch (opt) {
        case 'v':
            verbose = 1;
            putchar('\n');
            puts(TITLE " " VERSION);
            puts(CODERS);
            putchar('\n');
            break;
		case 'S':
			if (!(source = libnet_name_resolve(optarg, 0))) {
				fprintf(stderr, "Invalid source IP address: %s\n", optarg);
				exit(1);
			}
			if (verbose)
				printf("Source IP %s\n", optarg);
			break;
		case 'D':
			if (!(dest = libnet_name_resolve(optarg, 0))) {
				fprintf(stderr, "Invalid destination IP address: %s\n", optarg);
				exit(1);
			}
			if (verbose)
				printf("Destination IP %s\n", optarg);
			break;
		case 'p':
			switch (*optarg) {
			case 'H':
				ospftype = 0;
				break;
			case 'D':
				ospftype = 1;
				break;
            case 'L':
                ospftype = 2;
                break;
			case 'U':
				ospftype = 3;
				break;
			case 'R':
				ospftype = 4;
				break;
			case 'N':
				ospftype = 5;
				break;
			case 'M':
				ospftype = 6;
				break;
			case 'A':
				ospftype = 7;	
				break;
			}
		case 'F': 
			frag = atoi(optarg);
			break;
		case 'd':
			got_link = 1;
			device = optarg;
			break;
		case 'H':
			if (got_link)
            {
                sscanf(optarg, "%x:%x:%x:%x:%x:%x", &enet_tmp[0], &enet_tmp[1], &enet_tmp[2], &enet_tmp[3], &enet_tmp[4], &enet_tmp[5]);
                enet_src[0] = (u_char) enet_tmp[0];
                enet_src[1] = (u_char) enet_tmp[1];
                enet_src[2] = (u_char) enet_tmp[2];
                enet_src[3] = (u_char) enet_tmp[3];
                enet_src[4] = (u_char) enet_tmp[4];
                enet_src[5] = (u_char) enet_tmp[5];
            }
			break;
		case 'M':
			if (got_link)
            {
                sscanf(optarg, "%x:%x:%x:%x:%x:%x", &enet_tmp[0], &enet_tmp[1], &enet_tmp[2], &enet_tmp[3], &enet_tmp[4], &enet_tmp[5]);
                enet_dst[0] = (u_char) enet_tmp[0];
                enet_dst[1] = (u_char) enet_tmp[1];
                enet_dst[2] = (u_char) enet_tmp[2];
                enet_dst[3] = (u_char) enet_tmp[3];
                enet_dst[4] = (u_char) enet_tmp[4];
                enet_dst[5] = (u_char) enet_tmp[5];
            }
			break;
		case 'L':
			rtrid = atoi(optarg);
			break;
		case 'u':
			num = atoi(optarg);
			break;
		case 'z':
			mtusize = atoi(optarg);
			break;
		case 'm':
			metric = atoi(optarg);
			break;
		case 'x':
			exchange = strtoul(optarg, NULL, 0);
			break;
		case 'B':
			bcastnum = atoi(optarg);
			break;
		case 'y':
			rtrtype = strtoul(optarg, NULL, 0);
			break;
		case 'k':
			rtrdata = atoi(optarg);
			break;
		case 's':
			seqnum = atoi(optarg);
			break;
		case 'I':
			id = atoi(optarg);
			break;
		case 'T':
			ttl = atoi(optarg);
			break;
		case 't':
			tos = strtoul(optarg, NULL, 0);
			break;
		case 'n':
			mask = strtoul(optarg, NULL, 0);
			break;
		case 'b':
			bindata = 1;
			break;
		case 'P':
			file = optarg;
			if ((pay = fopen(file, "r")) == NULL) {
				printf("Payload file \"%s\"\n", file);
				exit(1);
			}
			break;
		case 'O':
			ooptions = strtoul(optarg, NULL, 0);
			break;
		case 'o':
			(u_char) * options = strtoul(optarg, NULL, 0);
			break;
		case 'l':
			interval = atoi(optarg);
			break;
		case 'f':
			as_fwd = strtoul(optarg, NULL, 0);
			break;
		case 'r':
			if (!(router = libnet_name_resolve(optarg, 0))) {
				fprintf(stderr, "Invalid advertising router address: %s\n", optarg);
				exit(1);
			}
			if (verbose)
				printf("Advertising Router IP: %s\n", optarg);
			break;
		case 'N':
			if (!(neighbor = libnet_name_resolve(optarg, 0))) {
				fprintf(stderr, "Invalid neighbor address: %s\n", optarg);
				exit(1);
			}
			break;
		case 'i':
			dead_int = atoi(optarg);
			break;
		case 'R':
			addrid = strtoul(optarg, NULL, 0);
			break;
		case 'A':
			addaid = strtoul(optarg, NULL, 0);
			break;
		case 'g':
			as_tag = atoi(optarg);
			break;
		case 'G':
			ospf_age = atoi(optarg);
			break;
		case '?':
			usage(argv[0]);
			break;
		}
	}

	if (ospftype == -1) {
		printf("\nOSPF Packet type not supplied.\n");
		exit(1);
	}
	if (verbose) {
		printf("\nOSPF Options: 0x%x\n", ooptions);
		printf("Priority: %d\n", priority);
		printf("Advertising Router ID: 0x%ld\n", addrid);
		printf("Advertising Area ID: 0x%ld\n", addaid);

	}
	if (ospftype == 1) {
		if (verbose)
			printf("Dead router interval: %d\n", dead_int);
	} else if (ospftype == 2) {
		if (verbose) {
			printf("Netmask: %ld\n", mask);
			printf("Sequence Number: %d\n", seqnum);
			printf("Router Advertisement Age: %d\n", ospf_age);
			printf("Link State ID: %d\n", rtrid);
		}
	} else if (ospftype == 3) {
		if (verbose)
			printf("Link State ID:	%d\n", rtrid);
	}
	if (verbose) {
		printf("IP ID: %d\n", id);
		printf("IP TTL: %d\n", ttl);
		printf("IP TOS: 0x%x\n", tos);
		printf("IP Frag: 0x%x\n", frag);
		printf("IP Options: %s\n", options);
	}
	if (got_payload) {
		if (bindata) {
			while (!feof(pay)) {
				fread(&buff, sizeof(buff), 1, pay);
				payload = malloc(sizeof(buff));
				strncpy(payload, buff, strlen(buff));
				if (verbose) {
					printf("BINARY Payload:\n");
					for (m = 0; m < strlen(payload); m++)
						printf("%x ", payload[m]);
					printf("\n");
				}
				if (buildospf() != -1) {
					if (verbose)
						printf("\nWrote OSPF packet successfully\n\n");
					else if (verbose)
						printf("\nUnable to write packet successfully\n");
				}
			}
		} else {
			while (fgets(buff, sizeof(buff), pay)) {
				payload = malloc(sizeof(buff));
				strncpy(payload, buff, strlen(buff));
				if (verbose) {
					printf("ASCII Payload:\n");
					printf("%s\n", payload);
				}
				if (buildospf() != -1) {
					if (verbose)
						printf("\nWrote OSPF packet successfully\n\n");
					else if (verbose)
						printf("\nUnable to write packet successfully\n");
				}
			}
		}
	} else {
		if (buildospf() != -1) {
			if (verbose)
				printf("\nWrote OSPF packet successfully\n\n");
			else if (verbose)
				printf("\nUnable to write packet successfully\n");
		}
	}
}

void
usage(char *arg)
{
    putchar('\n');
    puts(TITLE " " VERSION);
    puts(CODERS);
    putchar('\n');
    
	printf("OSPF usage:\n  %s [-v] [optlist]\n\n", arg);
	printf("OSPF Packet Types: \n"
	       "  -p <OSPF Protocol>\n"
	       "     -pH HELLO, -pD DBD, -pL LSR, -pU LSU, -pR LSA (router),\n"
		   "     -pN LSA (network), -pM LSA (summary), -pA LSA (AS)\n");
	printf("OSPF HELLO options: \n"
           "  -N <Neighbor Router Address>\n"
           "  -i <Dead Router Interval>\n"
           "  -l <OSPF Interval>\n");
	printf("OSPF DBD options: \n"
           "  -z <MAX DGRAM Length>\n"
		   "  -x <Exchange Type>\n");
	printf("OSPF LSU options: \n"
		   "  -B <num of LSAs to bcast>\n");
	printf("OSPF LSA related options: \n"
           "  -L <router id>\n"
           "  -G <LSA age>\n");
	printf("OSPF LSA_RTR options: \n"
		   "  -u <LSA_RTR num>\n"
		   "  -y <LSA_RTR router type>\n"
		   "  -k <LSA_RTR router data>\n");
	printf("OSPF LSA_AS_EXT options: \n"
		   "  -f <LSA_AS_EXT forward address>\n"
		   "  -g <LSA_AS_EXT tag>\n");
	printf("OSPF options: \n"
           "  -m <OSPF Metric>\n"
           "  -s <Sequence Number>\n"
           "  -r <Advertising Router Address>\n"
           "  -n <OSPF Netmask>\n"
           "  -O <OSPF Options>\n"
           "  -R <OSPF Router id>\n"
           "  -A <OSPF Area id>\n"
	       "  -P <Payload File (Binary or ASCII)>\n"
	       "  -b (Enable Binary Payload)\n"
	       "  (-v VERBOSE - packet struct to stdout)\n\n");
	printf("IP Options\n"
	       "  -S <Source Address>\n"
	       "  -D <Destination Address>\n"
	       "  -I <IP ID>\n"
	       "  -T <IP TTL>\n"
	       "  -t <IP/OSPF tos>\n"
		   "  -F <IP frag>\n"
	       "  -o <IP Options>\n\n");
	printf("Data Link Options: \n"
	       "  -d <Ethernet Device>\n"
	       "  -H <Source MAC Address>\n"
	       "  -M <Destination MAC Address>\n\n");
	printf("You must define a Source, Destination, Protocol & its dependent"
	       " options.\n\n");
	exit(1);
}

void
defaults()
{
	enet_src[0] = 0x02;
	enet_src[1] = 0x0f;
	enet_src[2] = 0x0a;
	enet_src[3] = 0x0d;
	enet_src[4] = 0x0e;
	enet_src[5] = 0x0d;

	enet_dst[0] = 0x0d;
	enet_dst[1] = 0x0e;
	enet_dst[2] = 0x0a;
	enet_dst[3] = 0x0d;
	enet_dst[4] = 0x00;
	enet_dst[5] = 0x01;

	
	id = 0;
	tos = IPTOS_LOWDELAY | IPTOS_THROUGHPUT;
	ttl = 254;
	mask = 0xffffff00;
	addrid = 0xff00ff00;
	addaid = 0xd00dd00d;
	rtrid = 42;
	ospf_age = 40;
	ooptions = 0x00;
	priority = 0x00;
	dead_int = 30;
	payload = NULL;
	payload_s = 0;
	*options = NULL;
	option_s = 0;
	interval = 2;
	seqnum = 420;
	frag = IP_DF;
	ospftype = -1;
}
